Index: trunk/gsdl/src/recpt/authenaction.cpp
===================================================================
--- trunk/gsdl/src/recpt/authenaction.cpp	(revision 542)
+++ trunk/gsdl/src/recpt/authenaction.cpp	(revision 543)
@@ -28,4 +28,7 @@
 /*
    $Log$
+   Revision 1.7  1999/09/07 23:04:29  rjmcnab
+   removed some compiler warnings
+
    Revision 1.6  1999/09/07 04:56:52  sjboddie
    added GPL notice
@@ -282,5 +285,5 @@
 
 void authenaction::define_internal_macros (const ColInfoResponse_t &/*collectinfo*/, displayclass &disp, 
-					   cgiargsclass &args, recptproto */*collectproto*/, 
+ 					   cgiargsclass &args, recptproto * /*collectproto*/, 
 					   ostream &/*logout*/) {
   // sets _authen:messageextra_ based on the value of args["us"]
@@ -320,10 +323,10 @@
 
 void authenaction::define_external_macros (const ColInfoResponse_t &/*collectinfo*/, displayclass &/*disp*/, 
-					   cgiargsclass &/*args*/, recptproto */*collectproto*/, 
+					   cgiargsclass &/*args*/, recptproto * /*collectproto*/, 
 					   ostream &/*logout*/) {
 }
 
 bool authenaction::do_action (cgiargsclass &args, const ColInfoResponse_t &/*collectinfo*/, 
-			      recptproto */*collectproto*/, displayclass &disp, 
+			      recptproto * /*collectproto*/, displayclass &disp, 
 			      outconvertclass &outconvert, ostream &textout, 
 			      ostream &/*logout*/) {
Index: trunk/gsdl/src/recpt/queryaction.cpp
===================================================================
--- trunk/gsdl/src/recpt/queryaction.cpp	(revision 542)
+++ trunk/gsdl/src/recpt/queryaction.cpp	(revision 543)
@@ -28,4 +28,7 @@
 /*
    $Log$
+   Revision 1.22  1999/09/07 23:08:51  rjmcnab
+   removed some compiler warnings
+
    Revision 1.21  1999/09/07 04:56:57  sjboddie
    added GPL notice
@@ -338,5 +341,5 @@
 
 void queryaction::define_internal_macros (const ColInfoResponse_t &/*collectinfo*/, displayclass &disp, 
-					  cgiargsclass &args, recptproto */*collectproto*/, 
+					  cgiargsclass &args, recptproto * /*collectproto*/, 
 					  ostream &/*logout*/) {
 
Index: trunk/gsdl/src/recpt/statusaction.cpp
===================================================================
--- trunk/gsdl/src/recpt/statusaction.cpp	(revision 542)
+++ trunk/gsdl/src/recpt/statusaction.cpp	(revision 543)
@@ -28,4 +28,7 @@
 /*
    $Log$
+   Revision 1.19  1999/09/07 23:09:40  rjmcnab
+   removed some compiler warnings
+
    Revision 1.18  1999/09/07 04:57:00  sjboddie
    added GPL notice
@@ -789,5 +792,5 @@
 
 bool statusaction::do_action (cgiargsclass &args, const ColInfoResponse_t &/*collectinfo*/, 
-			      recptproto */*collectproto*/, displayclass &disp, 
+			      recptproto * /*collectproto*/, displayclass &disp, 
 			      outconvertclass &outconvert, ostream &textout, 
 			      ostream &logout) {
Index: trunk/gsdl/src/recpt/tipaction.cpp
===================================================================
--- trunk/gsdl/src/recpt/tipaction.cpp	(revision 542)
+++ trunk/gsdl/src/recpt/tipaction.cpp	(revision 543)
@@ -28,4 +28,7 @@
 /*
    $Log$
+   Revision 1.5  1999/09/07 23:10:18  rjmcnab
+   removed some compiler warnings
+
    Revision 1.4  1999/09/07 04:57:00  sjboddie
    added GPL notice
@@ -61,5 +64,5 @@
 
 void tipaction::define_external_macros (const ColInfoResponse_t &/*collectinfo*/, displayclass &disp, 
-					cgiargsclass &args, recptproto */*collectproto*/, 
+					cgiargsclass &args, recptproto * /*collectproto*/, 
 					ostream &logout) {
   // define_external_macros sets the following macros:
Index: trunk/gsdl/src/recpt/usersaction.cpp
===================================================================
--- trunk/gsdl/src/recpt/usersaction.cpp	(revision 542)
+++ trunk/gsdl/src/recpt/usersaction.cpp	(revision 543)
@@ -28,4 +28,7 @@
 /*
    $Log$
+   Revision 1.5  1999/09/07 23:12:34  rjmcnab
+   removed some compiler warnings
+
    Revision 1.4  1999/09/07 04:57:01  sjboddie
    added GPL notice
@@ -199,10 +202,10 @@
 
 void usersaction::define_internal_macros (const ColInfoResponse_t &/*collectinfo*/, displayclass &/*disp*/, 
-					  cgiargsclass &/*args*/, recptproto */*collectproto*/, 
+					  cgiargsclass &/*args*/, recptproto * /*collectproto*/, 
 					  ostream &/*logout*/) {
 }
 
 void usersaction::define_external_macros (const ColInfoResponse_t &/*collectinfo*/, displayclass &/*disp*/, 
-					  cgiargsclass &/*args*/, recptproto */*collectproto*/, 
+					  cgiargsclass &/*args*/, recptproto * /*collectproto*/, 
 					  ostream &/*logout*/) {
 }